Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4176)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 4180)
@@ -74,719 +74,4 @@
 ! Formatting
 ! 
-! 3637 2018-12-20 01:51:36Z knoop
-! Implementation of the PALM module interface
-! 
-! 3597 2018-12-04 08:40:18Z maronga
-! Added checks for theta_2m
-! 
-! 3589 2018-11-30 15:09:51Z suehring
-! Move the control parameter "salsa" from salsa_mod to control_parameters 
-! (M. Kurppa)
-! 
-! 
-! 3582 2018-11-29 19:16:36Z suehring
-! Call nesting_offl_check_parameters
-! 
-! 3575 2018-11-28 15:06:32Z kanani
-! Bugfix for output time levels in parallel NetCDF output with spinup
-! 
-! 3569 2018-11-27 17:03:40Z kanani
-! Sort chemistry routine calls into list.
-! dom_dwd_user, Schrempf:
-! remove CALLs to uv exposure model, this is now part of biometeorology_mod
-! 
-! 3545 2018-11-21 11:19:41Z gronemeier
-! Call tcm_check_parameters before other modules
-! 
-! 3529 2018-11-15 21:03:15Z gronemeier
-! Save time zone in variable run_zone, change date format into YYYY-MM-DD
-! 
-! 3525 2018-11-14 16:06:14Z kanani
-! Changes related to clean-up of biometeorology (dom_dwd_user)
-! 
-! 3517 2018-11-12 16:27:08Z gronemeier
-! bugfix: renamed 'w*2pt*' -> 'w*2theta*'
-!                 'w*pt*2' -> 'w*theta*2'
-!
-! 2017-10-10 11:29:14Z monakurppa
-! Implementation of a new aerosol module salsa.
-! 
-! 3472 2018-10-30 20:43:50Z suehring
-! Bugfix: Missing air_chemistry statement for profile check
-! 
-! 3452 2018-10-30 13:13:34Z schwenkel
-! Bugfix for profiles output
-! 
-! 3448 2018-10-29 18:14:31Z kanani
-! Add biometeorology
-! 
-! 3421 2018-10-24 18:39:32Z gronemeier
-! Renamed output variables
-! Add checks for surface data output
-! 
-! 3419 2018-10-24 17:27:31Z gronemeier
-! Remove offline nesting in if clause for pressure top boundary condition
-! 
-! 3343 2018-10-15 10:38:52Z suehring
-! (from branch resler)
-! Add biometeorology,
-! fix for chemistry output,
-! increase of uv_heights dimension
-! 
-! 3312 2018-10-06 14:15:46Z knoop
-! small code rearrangements
-! 
-! 3301 2018-10-02 17:10:50Z gronemeier
-! corrected former revision section
-! 
-! 3298 2018-10-02 12:21:11Z kanani
-! - Minor formatting and remarks
-! - Call of chem_emissions_check_parameters commented 
-!   (preliminary, as there is still a bug in this subroutine) (forkel)
-! - Corrected call for chemistry profile output added (basit)
-! - Call for init_vertical_profiles for chemistry removed (basit)
-! - Call for chem_init_profiles removed (basit)
-! - Setting of initial profiles for chemstry (constant and call of 
-!   init_vertical_profiles) commented (forkel)
-!
-! 3294 2018-10-01 raasch
-! changes concerning modularization of ocean option,
-! init_vertical_profiles moved to separate file to avoid circular dependency
-! 
-! 3274 2018-09-24 knoop
-! Modularization of all bulk cloud physics code components
-! 
-! 3241 2018-09-12 raasch
-! unused variables removed
-! 
-! 3232 2018-09-07 raasch
-! references to mrun replaced by palmrun, and updated
-! 
-! 3182 2018-07-27 suehring
-! Rename boundary conditions in offline nesting
-! 
-! 3083 2018-06-19 gronemeier
-! Add inital profile output for e (TG)
-! 
-! 3065 2018-06-12 07:03:02Z Giersch
-! dz was replaced by dz(1), error message revised
-! 
-! 3049 2018-05-29 13:52:36Z Giersch
-! add variable description
-! 
-! 3046 2018-05-29 08:02:15Z Giersch
-! Error messages revised
-!
-! 3045 2018-05-28 07:55:41Z Giersch
-! Error messages revised
-! 
-! 3035 2018-05-24 09:35:20Z schwenkel
-! Add option to initialize warm air bubble close to surface
-!
-! 3034 2018-05-24 08:41:20Z raasch
-! bugfix: check that initializing_actions has been set
-!
-! 2980 2018-04-17 15:19:27Z suehring
-! Further improvement for spinup checks.
-! 
-! 2974 2018-04-16 12:59:52Z gronemeier
-! Bugfix: check if dt_data_output_av is zero in case of parallel NetCDF output
-! 
-! 2970 2018-04-13 15:09:23Z suehring
-! Bugfix in old large-scale forcing mode
-! 
-! 2964 2018-04-12 16:04:03Z Giersch
-! Calculation of fixed number of output time levels for parallel netcdf output
-! has been revised (based on calculations in netcdf_interface_mod)
-! 
-! 2938 2018-03-27 15:52:42Z suehring
-! - Revise start and end indices for imposing random disturbances in case of
-!   nesting or large-scale forcing.
-! - Remove check for inifor initialization in case of nested runs. 
-! - Adapt call to check for synthetic turbulence geneartor settings.
-! 
-! 2936 2018-03-27 14:49:27Z suehring
-! Check spinup in case of nested runs, spinup time and timestep must be 
-! identical to assure synchronuous simulations. 
-! 
-! 2932 2018-03-26 09:39:22Z maronga
-! renamed particles_par to particle_parameters
-! 
-! 2918 2018-03-21 15:52:14Z gronemeier
-! Add check for 1D model
-! 
-! 2883 2018-03-14 08:29:10Z Giersch
-! dt_dopr_listing is not set to the default value zero anymore
-! 
-! 2851 2018-03-05 14:39:31Z maronga
-! Bugfix: calculation of output time levels in case of restart runs (parallel
-! NetCDF)
-! 
-! 2836 2018-02-26 13:40:05Z Giersch
-! dt_dopr_listing is set to the default value zero 
-! 
-! 2817 2018-02-19 16:32:21Z knoop
-! Preliminary gust module interface implemented
-! 
-! 2798 2018-02-09 17:16:39Z suehring
-! Consider also default-type surfaces for surface temperature output. 
-! 
-! 2797 2018-02-08 13:24:35Z suehring
-! Enable output of ground-heat flux also at urban surfaces.
-! 
-! 2776 2018-01-31 10:44:42Z Giersch
-! Variable synthetic_turbulence_generator has been abbreviated
-! 
-! 2773 2018-01-30 14:12:54Z suehring
-! Check for consistent initialization in nesting mode added.
-! 
-! 2766 2018-01-22 17:17:47Z kanani
-! Removed preprocessor directive __chem
-! 
-! 2765 2018-01-22 11:34:58Z maronga
-! Renamed simulation_time_since_reference to 
-! time_to_be_simulated_from_reference_point
-! 
-! 2746 2018-01-15 12:06:04Z suehring
-! Move flag plant canopy to modules
-! 
-! 2743 2018-01-12 16:03:39Z suehring
-! In case of natural- and urban-type surfaces output surfaces fluxes in W/m2.
-! 
-! 2742 2018-01-12 14:59:47Z suehring
-! Enable output of surface temperature
-! 
-! 2735 2018-01-11 12:01:27Z suehring
-! output of r_a moved from land-surface to consider also urban-type surfaces
-! 
-! 2718 2018-01-02 08:49:38Z maronga
-! Corrected "Former revisions" section
-! 
-! 2696 2017-12-14 17:12:51Z kanani
-! Change in file header (GPL part)
-! Implementation of uv exposure model (FK)
-! + new possible value for dissipation_1d
-! Added checks for turbulence_closure_mod (TG)
-! Implementation of chemistry module (FK)
-! 
-! 2689 2017-12-12 17:46:55Z Giersch
-! Bugfix in if query
-! 
-! 2688 2017-12-12 17:27:04Z Giersch
-! Check if humidity is set to TRUE in the _p3d file for coupled runs
-! 
-! 2669 2017-12-06 16:03:27Z raasch
-! mrun-string replaced by palmrun
-! 
-! 2628 2017-11-20 12:40:38Z schwenkel
-! Enabled particle advection with grid stretching -> Removed parameter check
-! 
-! 2575 2017-10-24 09:57:58Z maronga
-! Renamed phi --> latitude
-! 
-! 2564 2017-10-19 15:56:56Z Giersch
-! Variable wind_turbine was added to control_parameters.
-! 
-! 2550 2017-10-16 17:12:01Z boeske
-! Added checks for complex terrain simulations
-! 
-! 2513 2017-10-04 09:24:39Z kanani
-! Bugfix for some dopr(_initial)_index values and units connected to 
-! passive-scalar output
-! 
-! 2508 2017-10-02 08:57:09Z suehring
-! Bugfix, change default value of vertical_gradient level in order to consider 
-! also ocean runs 
-! 
-! 2422 2017-09-08 08:25:41Z raasch
-! error message in case of missing "restart" file activation string
-! 
-! 2375 2017-08-29 14:10:28Z schwenkel
-! Added aerosol for bulk microphysics
-! 
-! 2365 2017-08-21 14:59:59Z kanani
-! Vertical grid nesting implemented: Check coupling mode. Generate file header
-! (SadiqHuq)
-! 
-! 2354 2017-08-17 10:49:36Z schwenkel
-! Bugfix correlated to lsm_check_data_output_pr.
-! If-statement for following checks is essential, otherwise units for lsm output 
-! are set to 'illegal' and palm will be aborted.
-! 
-! 2348 2017-08-10 10:40:10Z kanani
-! New: Check for simultaneous use of geostrophic wind and u_profile/v_profile
-! 
-! 2345 2017-08-09 11:50:30Z Giersch
-! Remove error message PA0156 and the conserve_volume_flow_mode option 
-! inflow_profile
-! 
-! 2339 2017-08-07 13:55:26Z raasch
-! corrected timestamp in header
-! 
-! 2338 2017-08-07 12:15:38Z gronemeier
-! Modularize 1D model
-! 
-! 2329 2017-08-03 14:24:56Z knoop
-! Bugfix: index corrected for rho_air and rho_air_zw output
-! 
-! 2320 2017-07-21 12:47:43Z suehring
-! Modularize large-scale forcing and nudging
-!
-! 2312 2017-07-14 20:26:51Z hoffmann
-! PA0349 and PA0420 removed.
-!
-! 2300 2017-06-29 13:31:14Z raasch
-! host-specific settings and checks removed
-!
-! 2292 2017-06-20 09:51:42Z schwenkel
-! Implementation of new microphysic scheme: cloud_scheme = 'morrison'
-! includes two more prognostic equations for cloud drop concentration (nc)
-! and cloud water content (qc).
-!
-! 2274 2017-06-09 13:27:48Z Giersch
-! Changed error messages
-!
-! 2271 2017-06-09 12:34:55Z sward
-! roughness-length check altered
-! Error messages fixed
-!
-! 2270 2017-06-09 12:18:47Z maronga
-! Revised numbering (removed 2 timeseries)
-!
-! 2259 2017-06-08 09:09:11Z gronemeier
-! Implemented synthetic turbulence generator
-!
-! 2251 2017-06-06 15:10:46Z Giersch
-!
-! 2250 2017-06-06 15:07:12Z Giersch
-! Doxygen comment added
-!
-! 2248 2017-06-06 13:52:54Z sward
-! Error message fixed
-!
-! 2209 2017-04-19 09:34:46Z kanani
-! Check for plant canopy model output
-!
-! 2200 2017-04-11 11:37:51Z suehring
-! monotonic_adjustment removed
-!
-! 2178 2017-03-17 11:07:39Z hellstea
-! Index limits for perturbations are now set also in case of nested
-! boundary conditions
-!
-! 2169 2017-03-06 18:16:35Z suehring
-! Bugfix, move setting for topography grid convention to init_grid
-!
-! 2118 2017-01-17 16:38:49Z raasch
-! OpenACC related parts of code removed
-!
-! 2088 2016-12-19 16:30:25Z suehring
-! Bugfix in initial salinity profile
-!
-! 2084 2016-12-09 15:59:42Z knoop
-! Removed anelastic + multigrid error message
-!
-! 2052 2016-11-08 15:14:59Z gronemeier
-! Bugfix: remove setting of default value for recycling_width
-!
-! 2050 2016-11-08 15:00:55Z gronemeier
-! Implement turbulent outflow condition
-!
-! 2044 2016-11-02 16:44:25Z knoop
-! Added error code for anelastic approximation
-!
-! 2042 2016-11-02 13:47:31Z suehring
-! Additional checks for wall_heatflux, wall_humidityflux and wall_scalarflux.
-! Bugfix, check for constant_scalarflux.
-!
-! 2040 2016-10-26 16:58:09Z gronemeier
-! Removed check for statistic_regions > 9.
-!
-! 2037 2016-10-26 11:15:40Z knoop
-! Anelastic approximation implemented
-!
-! 2031 2016-10-21 15:11:58Z knoop
-! renamed variable rho to rho_ocean
-!
-! 2026 2016-10-18 10:27:02Z suehring
-! Bugfix, enable output of s*2
-!
-! 2024 2016-10-12 16:42:37Z kanani
-! Added missing CASE, error message and unit for ssws*,
-! increased number of possible output quantities to 500.
-!
-! 2011 2016-09-19 17:29:57Z kanani
-! Flag urban_surface is now defined in module control_parameters,
-! changed prefix for urban surface model output to "usm_",
-! added flag lsf_exception (inipar-Namelist parameter) to allow explicit
-! enabling of large scale forcing together with buildings on flat terrain,
-! introduced control parameter varnamelength for LEN of var.
-!
-! 2007 2016-08-24 15:47:17Z kanani
-! Added checks for the urban surface model,
-! increased counter in DO WHILE loop over data_output (for urban surface output)
-!
-! 2000 2016-08-20 18:09:15Z knoop
-! Forced header and separation lines into 80 columns
-!
-! 1994 2016-08-15 09:52:21Z suehring
-! Add missing check for bulk_cloud_model and cloud_droplets
-!
-! 1992 2016-08-12 15:14:59Z suehring
-! New checks for top_scalarflux
-! Bugfixes concerning data output of profiles in case of passive_scalar
-!
-! 1984 2016-08-01 14:48:05Z suehring
-! Bugfix: checking for bottom and top boundary condition for humidity and scalars
-!
-! 1972 2016-07-26 07:52:02Z maronga
-! Removed check of lai* (done in land surface module)
-!
-! 1970 2016-07-18 14:27:12Z suehring
-! Bugfix, check for ibc_q_b and constant_waterflux in case of land-surface scheme
-!
-! 1962 2016-07-13 09:16:44Z suehring
-! typo removed
-!
-! 1960 2016-07-12 16:34:24Z suehring
-! Separate checks and calculations for humidity and passive scalar. Therefore,
-! a subroutine to calculate vertical gradients is introduced, in order  to reduce
-! redundance.
-! Additional check - large-scale forcing is not implemented for passive scalars
-! so far.
-!
-! 1931 2016-06-10 12:06:59Z suehring
-! Rename multigrid into multigrid_noopt and multigrid_fast into multigrid
-!
-! 1929 2016-06-09 16:25:25Z suehring
-! Bugfix in check for use_upstream_for_tke
-!
-! 1918 2016-05-27 14:35:57Z raasch
-! setting of a fixed reference state ('single_value') for ocean runs removed
-!
-! 1914 2016-05-26 14:44:07Z witha
-! Added checks for the wind turbine model
-!
-! 1841 2016-04-07 19:14:06Z raasch
-! redundant location message removed
-!
-! 1833 2016-04-07 14:23:03Z raasch
-! check of spectra quantities moved to spectra_mod
-!
-! 1829 2016-04-07 12:16:29Z maronga
-! Bugfix: output of user defined data required reset of the string 'unit'
-!
-! 1826 2016-04-07 12:01:39Z maronga
-! Moved checks for radiation model to the respective module.
-! Moved checks for plant canopy model to the respective module.
-! Bugfix for check of too large roughness_length
-!
-! 1824 2016-04-07 09:55:29Z gronemeier
-! Check if roughness_length < dz/2. Moved location_message(finished) to the end.
-!
-! 1822 2016-04-07 07:49:42Z hoffmann
-! PALM collision kernel deleted. Collision algorithms are checked for correct
-! spelling.
-!
-! Tails removed.
-! !
-! Checks for use_sgs_for_particles adopted for the use of droplets with
-! use_sgs_for_particles adopted.
-!
-! Unused variables removed.
-!
-! 1817 2016-04-06 15:44:20Z maronga
-! Moved checks for land_surface model to the respective module
-!
-! 1806 2016-04-05 18:55:35Z gronemeier
-! Check for recycling_yshift
-!
-! 1804 2016-04-05 16:30:18Z maronga
-! Removed code for parameter file check (__check)
-!
-! 1795 2016-03-18 15:00:53Z raasch
-! Bugfix: setting of initial scalar profile in ocean
-!
-! 1788 2016-03-10 11:01:04Z maronga
-! Added check for use of most_method = 'lookup' in combination with water
-! surface presribed in the land surface model. Added output of z0q.
-! Syntax layout improved.
-!
-! 1786 2016-03-08 05:49:27Z raasch
-! cpp-direktives for spectra removed, check of spectra level removed
-!
-! 1783 2016-03-06 18:36:17Z raasch
-! netcdf variables and module name changed,
-! check of netcdf precision removed (is done in the netcdf module)
-!
-! 1764 2016-02-28 12:45:19Z raasch
-! output of nest id in run description header,
-! bugfix: check of validity of lateral boundary conditions moved to parin
-!
-! 1762 2016-02-25 12:31:13Z hellstea
-! Introduction of nested domain feature
-!
-! 1745 2016-02-05 13:06:51Z gronemeier
-! Bugfix: check data output intervals to be /= 0.0 in case of parallel NetCDF4
-!
-! 1701 2015-11-02 07:43:04Z maronga
-! Bugfix: definition of rad_net timeseries was missing
-!
-! 1691 2015-10-26 16:17:44Z maronga
-! Added output of Obukhov length (ol) and radiative heating rates for RRTMG.
-! Added checks for use of radiation / lsm with topography.
-!
-! 1682 2015-10-07 23:56:08Z knoop
-! Code annotations made doxygen readable
-!
-! 1606 2015-06-29 10:43:37Z maronga
-! Added check for use of RRTMG without netCDF.
-!
-! 1587 2015-05-04 14:19:01Z maronga
-! Added check for set of albedos when using RRTMG
-!
-! 1585 2015-04-30 07:05:52Z maronga
-! Added support for RRTMG
-!
-! 1575 2015-03-27 09:56:27Z raasch
-! multigrid_fast added as allowed pressure solver
-!
-! 1573 2015-03-23 17:53:37Z suehring
-! Bugfix: check for advection schemes in case of non-cyclic boundary conditions
-!
-! 1557 2015-03-05 16:43:04Z suehring
-! Added checks for monotonic limiter
-!
-! 1555 2015-03-04 17:44:27Z maronga
-! Added output of r_a and r_s. Renumbering of LSM PA-messages.
-!
-! 1553 2015-03-03 17:33:54Z maronga
-! Removed check for missing soil temperature profile as default values were added.
-!
-! 1551 2015-03-03 14:18:16Z maronga
-! Added various checks for land surface and radiation model. In the course of this
-! action, the length of the variable var has to be increased
-!
-! 1504 2014-12-04 09:23:49Z maronga
-! Bugfix: check for large_scale forcing got lost.
-!
-! 1500 2014-12-03 17:42:41Z maronga
-! Boundary conditions changed to dirichlet for land surface model
-!
-! 1496 2014-12-02 17:25:50Z maronga
-! Added checks for the land surface model
-!
-! 1484 2014-10-21 10:53:05Z kanani
-! Changes due to new module structure of the plant canopy model:
-!   module plant_canopy_model_mod added,
-!   checks regarding usage of new method for leaf area density profile
-!   construction added,
-!   lad-profile construction moved to new subroutine init_plant_canopy within
-!   the module plant_canopy_model_mod,
-!   drag_coefficient renamed to canopy_drag_coeff.
-! Missing KIND-attribute for REAL constant added
-!
-! 1455 2014-08-29 10:47:47Z heinze
-! empty time records in volume, cross-section and masked data output prevented
-! in case of non-parallel netcdf-output in restart runs
-!
-! 1429 2014-07-15 12:53:45Z knoop
-! run_description_header exended to provide ensemble_member_nr if specified
-!
-! 1425 2014-07-05 10:57:53Z knoop
-! bugfix: perturbation domain modified for parallel random number generator
-!
-! 1402 2014-05-09 14:25:13Z raasch
-! location messages modified
-!
-! 1400 2014-05-09 14:03:54Z knoop
-! Check random generator extended by option random-parallel
-!
-! 1384 2014-05-02 14:31:06Z raasch
-! location messages added
-!
-! 1365 2014-04-22 15:03:56Z boeske
-! Usage of large scale forcing for pt and q enabled:
-! output for profiles of large scale advection (td_lsa_lpt, td_lsa_q),
-! large scale subsidence (td_sub_lpt, td_sub_q)
-! and nudging tendencies (td_nud_lpt, td_nud_q, td_nud_u and td_nud_v) added,
-! check if use_subsidence_tendencies is used correctly
-!
-! 1361 2014-04-16 15:17:48Z hoffmann
-! PA0363 removed
-! PA0362 changed
-!
-! 1359 2014-04-11 17:15:14Z hoffmann
-! Do not allow the execution of PALM with use_particle_tails, since particle
-! tails are currently not supported by our new particle structure.
-!
-! PA0084 not necessary for new particle structure
-!
-! 1353 2014-04-08 15:21:23Z heinze
-! REAL constants provided with KIND-attribute
-!
-! 1330 2014-03-24 17:29:32Z suehring
-! In case of SGS-particle velocity advection of TKE is also allowed with
-! dissipative 5th-order scheme.
-!
-! 1327 2014-03-21 11:00:16Z raasch
-! "baroclinicity" renamed "baroclinity", "ocean version" replaced by "ocean mode"
-! bugfix: duplicate error message 56 removed,
-! check of data_output_format and do3d_compress removed
-!
-! 1322 2014-03-20 16:38:49Z raasch
-! some REAL constants defined as wp-kind
-!
-! 1320 2014-03-20 08:40:49Z raasch
-! Kind-parameters added to all INTEGER and REAL declaration statements,
-! kinds are defined in new module kinds,
-! revision history before 2012 removed,
-! comment fields (!:) to be used for variable explanations added to
-! all variable declaration statements
-!
-! 1308 2014-03-13 14:58:42Z fricke
-! +netcdf_data_format_save
-! Calculate fixed number of output time levels for parallel netcdf output.
-! For masked data, parallel netcdf output is not tested so far, hence
-! netcdf_data_format is switched back to non-paralell output.
-!
-! 1299 2014-03-06 13:15:21Z heinze
-! enable usage of large_scale subsidence in combination with large_scale_forcing
-! output for profile of large scale vertical velocity w_subs added
-!
-! 1276 2014-01-15 13:40:41Z heinze
-! Use LSF_DATA also in case of Dirichlet bottom boundary condition for scalars
-!
-! 1241 2013-10-30 11:36:58Z heinze
-! output for profiles of ug and vg added
-! set surface_heatflux and surface_waterflux also in dependence on
-! large_scale_forcing
-! checks for nudging and large scale forcing from external file
-!
-! 1236 2013-09-27 07:21:13Z raasch
-! check number of spectra levels
-!
-! 1216 2013-08-26 09:31:42Z raasch
-! check for transpose_compute_overlap (temporary)
-!
-! 1214 2013-08-21 12:29:17Z kanani
-! additional check for simultaneous use of vertical grid stretching
-! and particle advection
-!
-! 1212 2013-08-15 08:46:27Z raasch
-! checks for poisfft_hybrid removed
-!
-! 1210 2013-08-14 10:58:20Z raasch
-! check for fftw
-!
-! 1179 2013-06-14 05:57:58Z raasch
-! checks and settings of buoyancy parameters and switches revised,
-! initial profile for rho_ocean added to hom (id=77)
-!
-! 1174 2013-05-31 10:28:08Z gryschka
-! Bugfix in computing initial profiles for ug, vg, lad, q in case of Atmosphere
-!
-! 1159 2013-05-21 11:58:22Z fricke
-! bc_lr/ns_dirneu/neudir removed
-!
-! 1115 2013-03-26 18:16:16Z hoffmann
-! unused variables removed
-! drizzle can be used without precipitation
-!
-! 1111 2013-03-08 23:54:10Z raasch
-! ibc_p_b = 2 removed
-!
-! 1103 2013-02-20 02:15:53Z raasch
-! Bugfix: turbulent inflow must not require cyclic fill in restart runs
-!
-! 1092 2013-02-02 11:24:22Z raasch
-! unused variables removed
-!
-! 1069 2012-11-28 16:18:43Z maronga
-! allow usage of topography in combination with cloud physics
-!
-! 1065 2012-11-22 17:42:36Z hoffmann
-! Bugfix: It is not allowed to use cloud_scheme = seifert_beheng without
-!         precipitation in order to save computational resources.
-!
-! 1060 2012-11-21 07:19:51Z raasch
-! additional check for parameter turbulent_inflow
-!
-! 1053 2012-11-13 17:11:03Z hoffmann
-! necessary changes for the new two-moment cloud physics scheme added:
-! - check cloud physics scheme (Kessler or Seifert and Beheng)
-! - plant_canopy is not allowed
-! - currently, only cache loop_optimization is allowed
-! - initial profiles of nr, qr
-! - boundary condition of nr, qr
-! - check output quantities (qr, nr, prr)
-!
-! 1036 2012-10-22 13:43:42Z raasch
-! code put under GPL (PALM 3.9)
-!
-! 1031/1034 2012-10-22 11:32:49Z raasch
-! check of netcdf4 parallel file support
-!
-! 1019 2012-09-28 06:46:45Z raasch
-! non-optimized version of prognostic_equations not allowed any more
-!
-! 1015 2012-09-27 09:23:24Z raasch
-! acc allowed for loop optimization,
-! checks for adjustment of mixing length to the Prandtl mixing length removed
-!
-! 1003 2012-09-14 14:35:53Z raasch
-! checks for cases with unequal subdomain sizes removed
-!
-! 1001 2012-09-13 14:08:46Z raasch
-! all actions concerning leapfrog- and upstream-spline-scheme removed
-!
-! 996 2012-09-07 10:41:47Z raasch
-! little reformatting
-
-! 978 2012-08-09 08:28:32Z fricke
-! setting of bc_lr/ns_dirneu/neudir
-! outflow damping layer removed
-! check for z0h*
-! check for pt_damping_width
-!
-! 964 2012-07-26 09:14:24Z raasch
-! check of old profil-parameters removed
-!
-! 940 2012-07-09 14:31:00Z raasch
-! checks for parameter neutral
-!
-! 924 2012-06-06 07:44:41Z maronga
-! Bugfix: preprocessor directives caused error during compilation
-!
-! 892 2012-05-02 13:51:44Z maronga
-! Bugfix for parameter file check ( excluding __netcdf4 )
-!
-! 866 2012-03-28 06:44:41Z raasch
-! use only 60% of the geostrophic wind as translation speed in case of Galilean
-! transformation and use_ug_for_galilei_tr = .T. in order to mimimize the
-! timestep
-!
-! 861 2012-03-26 14:18:34Z suehring
-! Check for topography and ws-scheme removed.
-! Check for loop_optimization = 'vector' and ws-scheme removed.
-!
-! 845 2012-03-07 10:23:05Z maronga
-! Bugfix: exclude __netcdf4 directive part from namelist file check compilation
-!
-! 828 2012-02-21 12:00:36Z raasch
-! check of collision_kernel extended
-!
-! 825 2012-02-19 03:03:44Z raasch
-! check for collision_kernel and curvature_solution_effects
-!
-! 809 2012-01-30 13:32:58Z maronga
-! Bugfix: replaced .AND. and .NOT. with && and ! in the preprocessor directives
-!
-! 807 2012-01-25 11:53:51Z maronga
-! New cpp directive "__check" implemented which is used by check_namelist_files
-!
-! Revision 1.1  1997/08/26 06:29:23  raasch
-! Initial revision
-!
 !
 ! Description: