Index: palm/trunk/TESTS/cases/urban_environment_restart/MONITORING/urban_environment_restart_rc
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_restart/MONITORING/urban_environment_restart_rc	(revision 4118)
+++ palm/trunk/TESTS/cases/urban_environment_restart/MONITORING/urban_environment_restart_rc	(revision 4186)
@@ -39,5 +39,5 @@
   1    123 00:01:33.11   0.7560A  -2.3823  -1.2611   1.4254  0.070  0.63  -0.832E+00     40.  0.134E+01  0.549E-01  0.143E-02  0.184E-03   60   0   9   13  13   0    7  14   3    0.000    0.000       0
   1    124 00:01:33.87   0.7560A  -2.3824  -1.2641   1.4252  0.070  0.63  -0.834E+00     40.  0.134E+01  0.550E-01  0.144E-02  0.182E-03   60   0   8    8  14   5    7  14   3    0.000    0.000       0
-  1    125 00:01:34.62   0.7560A  -2.3825  -1.2789   1.4249  0.070  0.63  -0.836E+00     40.  0.134E+01  0.550E-01  0.145E-02  0.181E-03   60  19   7    8  14   5    7  14   3    0.000    0.000       0
+  1    125 00:01:34.62   0.7560A  -2.3825  -1.2788   1.4249  0.070  0.63  -0.836E+00     40.  0.134E+01  0.550E-01  0.145E-02  0.181E-03   60  19   7    8  14   5    7  14   3    0.000    0.000       0
   1    126 00:01:35.38   0.7550A  -2.3825  -1.2907   1.4246  0.070  0.62  -0.839E+00     40.  0.134E+01  0.550E-01  0.146E-02  0.179E-03   60  19   6    8  14   5    7  14   3    0.000    0.000       0
   1    127 00:01:36.13   0.7550A  -2.3826  -1.2999   1.4241  0.070  0.62  -0.841E+00     40.  0.134E+01  0.550E-01  0.146E-02  0.177E-03   60  19   6    8  14   5    7  14   3    0.000    0.000       0
@@ -55,7 +55,7 @@
   1    139 00:01:45.19   0.7550A  -2.3835  -1.2294   1.4549  0.069  0.59  -0.857E+00     40.  0.133E+01  0.541E-01  0.159E-02  0.160E-03   60  15  14    8  14   5    8  13   3    0.000    0.000       0
   1    140 00:01:45.95   0.7550A  -2.3836  -1.2273   1.4608  0.069  0.59  -0.857E+00     40.  0.133E+01  0.539E-01  0.159E-02  0.159E-03   60  15  14    6  13   5    8  13   3    0.000    0.000       0
-  1    141 00:01:46.70   0.7550A  -2.3836  -1.2246   1.4649  0.069  0.59  -0.856E+00     40.  0.133E+01  0.537E-01  0.160E-02  0.158E-03   60  14  12    6  13   5    8  13   3    0.000    0.000       0
+  1    141 00:01:46.70   0.7550A  -2.3836  -1.2245   1.4649  0.069  0.59  -0.856E+00     40.  0.133E+01  0.537E-01  0.160E-02  0.158E-03   60  14  12    6  13   5    8  13   3    0.000    0.000       0
   1    142 00:01:47.46   0.7550A  -2.3837  -1.2167   1.4669  0.068  0.59  -0.857E+00     40.  0.133E+01  0.535E-01  0.160E-02  0.157E-03   60  14  11    6  13   5    8  13   3    0.000    0.000       0
-  1    143 00:01:48.21   0.7550A  -2.3838  -1.2031   1.4665  0.068  0.59  -0.857E+00     40.  0.133E+01  0.533E-01  0.161E-02  0.155E-03   60  14  11    6  13   5    8  13   3    0.000    0.000       0
+  1    143 00:01:48.21   0.7550A  -2.3838  -1.2030   1.4665  0.068  0.59  -0.857E+00     40.  0.133E+01  0.533E-01  0.161E-02  0.155E-03   60  14  11    6  13   5    8  13   3    0.000    0.000       0
   1    144 00:01:48.97   0.7550A  -2.3839  -1.1872   1.4636  0.068  0.59  -0.859E+00     40.  0.133E+01  0.530E-01  0.161E-02  0.154E-03   60  13   9   17   8  19    8  13   3    0.000    0.000       0
   1    145 00:01:49.72   0.7550A  -2.3839  -1.1785   1.4578  0.068  0.58  -0.861E+00     40.  0.133E+01  0.528E-01  0.162E-02  0.154E-03   60  13   8   17   8  19    8  13   3    0.000    0.000       0
@@ -73,5 +73,5 @@
   1    157 00:01:58.78   0.7550A  -2.3848  -1.0776   1.4710  0.066  0.61  -0.892E+00     48.  0.132E+01  0.490E-01  0.164E-02  0.149E-03   60  10  19   18   7  17    8  14   3    0.000    0.000       0
   1    158 00:01:59.54   0.7550A  -2.3849  -1.0860   1.4747  0.066  0.61  -0.894E+00     48.  0.132E+01  0.486E-01  0.164E-02  0.149E-03   60   9  17   16   5  18    8  14   3    0.000    0.000       0
-  1    159 00:02:00.29   0.7550A  -2.3849  -1.0981   1.4775  0.066  0.61  -0.892E+00     48.  0.132E+01  0.483E-01  0.163E-02  0.149E-03   60   9  16   16   5  18    8  14   3    0.000    0.000       0
+  1    159 00:02:00.29   0.7550A  -2.3849  -1.0980   1.4775  0.066  0.61  -0.892E+00     48.  0.132E+01  0.483E-01  0.163E-02  0.149E-03   60   9  16   16   5  18    8  14   3    0.000    0.000       0
   1    160 00:02:01.05   0.7550A  -2.3850  -1.0980   1.4792  0.065  0.61  -0.892E+00     48.  0.132E+01  0.480E-01  0.163E-02  0.149E-03   60   9  16   16   5  18    8  14   3    0.000    0.000       0
   1    161 00:02:01.80   0.7550A  -2.3851  -1.0864   1.4797  0.065  0.61  -0.897E+00     48.  0.132E+01  0.476E-01  0.163E-02  0.148E-03   60   8  14   16   5  18    8  14   3    0.000    0.000       0
@@ -83,5 +83,5 @@
   1    167 00:02:06.33   0.7550A  -2.3855  -1.0470   1.4344  0.065  0.63  -0.897E+00     48.  0.131E+01  0.456E-01  0.161E-02  0.143E-03   60   6   8   18   4  15    8  14   3    0.000    0.000       0
   1    168 00:02:07.09   0.7550A  -2.3856  -1.0456   1.4164  0.064  0.63  -0.896E+00     48.  0.131E+01  0.453E-01  0.160E-02  0.142E-03   60   6   7   16   5  16    8  14   3    0.000    0.000       0
-  1    169 00:02:07.84   0.7550A  -2.3857  -1.0536   1.3949  0.064  0.63  -0.896E+00     48.  0.131E+01  0.450E-01  0.159E-02  0.140E-03   60   6   7   16   5  16    8  14   3    0.000    0.000       0
+  1    169 00:02:07.84   0.7550A  -2.3857  -1.0536   1.3948  0.064  0.63  -0.896E+00     48.  0.131E+01  0.450E-01  0.159E-02  0.140E-03   60   6   7   16   5  16    8  14   3    0.000    0.000       0
   1    170 00:02:08.60   0.7540A  -2.3857  -1.0444   1.3697  0.064  0.64  -0.896E+00     48.  0.131E+01  0.446E-01  0.159E-02  0.138E-03   60   6   7   16   5  16    8  14   3    0.000    0.000       0
   1    171 00:02:09.35   0.7540A  -2.3858  -1.0253   1.3607  0.064  0.64  -0.897E+00     48.  0.131E+01  0.443E-01  0.158E-02  0.136E-03   60   5   5   19   3  14    9  14   3    0.000    0.000       0