Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4187)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4188)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Minor adjustment in error numbers, typos corrected
+! 
+! 4187 2019-08-26 12:43:15Z suehring
 ! Adjust message call in case of local checks
 ! 
@@ -3169,5 +3172,5 @@
                 WRITE( message_string, * )                                     &
                                  'surface element at grid point (j,i) = (',    &
-                                 j, i, ') is not a vegation surface, ',        &
+                                 j, i, ') is not a vegetation surface, ',      &
                                  'so that information given in ',              &
                                  'vegetation_pars at this point is neglected.' 
@@ -3245,8 +3248,8 @@
                    WRITE( message_string, * )                                  &
                                  'surface element at grid point (j,i) = (',    &
-                                 j, i, ') is not a vegation surface, ',        &
+                                 j, i, ') is not a vegetation surface, ',      &
                                  'so that information given in ',              &
                                  'vegetation_pars at this point is neglected.' 
-                   CALL message( 'land_surface_model_mod', 'PA0437', 0, 0, myid, 6, 0 )
+                   CALL message( 'land_surface_model_mod', 'PA0436', 0, 0, myid, 6, 0 )
                 ELSE
 
@@ -3520,5 +3523,5 @@
                               'so that information given in ',                 &
                               'water_pars at this point is neglected.' 
-                   CALL message( 'land_surface_model_mod', 'PA0646',           &
+                   CALL message( 'land_surface_model_mod', 'PA0645',           &
                                   0, 0, myid, 6, 0 )
                 ELSE
@@ -3886,5 +3889,5 @@
                                  'so that information given in ',              &
                                  'pavement_pars at this point is neglected.' 
-                   CALL message( 'land_surface_model_mod', 'PA0670', 0, 0, myid, 6, 0 )
+                   CALL message( 'land_surface_model_mod', 'PA0647', 0, 0, myid, 6, 0 )
                 ELSE
 
@@ -4593,5 +4596,5 @@
              message_string = 'For non-pavement surfaces the combination ' //  &
                               ' lai = 0.0 and c_veg = 1.0 is not allowed.'
-             CALL message( 'lsm_rrd_local', 'PA0672', 2, 2, 0, 6, 0 )
+             CALL message( 'lsm_rrd_local', 'PA0671', 2, 2, 0, 6, 0 )
           ENDIF
        ENDDO
Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4187)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4188)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! Minor adjustment in error number
+! 
+! 4187 2019-08-26 12:43:15Z suehring
 ! Give specific error numbers instead of PA0999
 ! 
@@ -433,5 +436,5 @@
                            TRIM( coupling_char ) // ' requires ' //            &
                            'canopy_mode = read_from_file_3d'
-          CALL message( 'pcm_check_parameters', 'PA0673', 1, 2, 0, 6, 0 )
+          CALL message( 'pcm_check_parameters', 'PA0672', 1, 2, 0, 6, 0 )
        ENDIF
 
Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4187)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4188)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Minor adjustment in error message
+! 
+! 4187 2019-08-26 12:43:15Z suehring
 ! - Take external radiation from root domain dynamic input if not provided for 
 !   each nested domain
@@ -2473,5 +2476,5 @@
                               'dynamic input for the child domain(s) is ' //   &
                               'provided, at least one for the root domain ' // &
-                              'needs to be provided.'
+                              'is needed.'
              CALL message( 'radiation_init', 'PA0315', 1, 2, 0, 6, 0 )
           ENDIF